##// END OF EJS Templates
a
Unknown -
r489:54e2ae4a5bc6
parent child
Show More
@@ -1,859 +1,864
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63 # Kernel deb packages for 32bit kernel
64 64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 68 # Default precompiled 64bit kernel
69 69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 70 # Generic
71 71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72 72
73 73 # Build directories
74 74 WORKDIR=$(pwd)
75 75 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
76 76 BUILDDIR="${BASEDIR}/build"
77 77
78 78 # Chroot directories
79 79 R="${BUILDDIR}/chroot"
80 80 ETC_DIR="${R}/etc"
81 81 LIB_DIR="${R}/lib"
82 82 BOOT_DIR="${R}/boot/firmware"
83 83 KERNEL_DIR="${R}/usr/src/linux"
84 84 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
85 85 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
86 86
87 87 # Firmware directory: Blank if download from github
88 88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
89 89
90 90 # General settings
91 91 SET_ARCH=${SET_ARCH:=32}
92 92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
93 93 PASSWORD=${PASSWORD:=raspberry}
94 94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
95 95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
96 96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
97 97 EXPANDROOT=${EXPANDROOT:=true}
98 98
99 99 # Keyboard settings
100 100 XKB_MODEL=${XKB_MODEL:=""}
101 101 XKB_LAYOUT=${XKB_LAYOUT:=""}
102 102 XKB_VARIANT=${XKB_VARIANT:=""}
103 103 XKB_OPTIONS=${XKB_OPTIONS:=""}
104 104
105 105 # Network settings (DHCP)
106 106 ENABLE_DHCP=${ENABLE_DHCP:=true}
107 107
108 108 # Network settings (static)
109 109 NET_ADDRESS=${NET_ADDRESS:=""}
110 110 NET_GATEWAY=${NET_GATEWAY:=""}
111 111 NET_DNS_1=${NET_DNS_1:=""}
112 112 NET_DNS_2=${NET_DNS_2:=""}
113 113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
114 114 NET_NTP_1=${NET_NTP_1:=""}
115 115 NET_NTP_2=${NET_NTP_2:=""}
116 116
117 117 # APT settings
118 118 APT_PROXY=${APT_PROXY:=""}
119 119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
120 120
121 121 # Feature settings
122 122 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
123 123 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
124 124 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
125 125 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
126 126 ENABLE_I2C=${ENABLE_I2C:=false}
127 127 ENABLE_SPI=${ENABLE_SPI:=false}
128 128 ENABLE_IPV6=${ENABLE_IPV6:=true}
129 129 ENABLE_SSHD=${ENABLE_SSHD:=true}
130 130 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
131 131 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
132 132 ENABLE_SOUND=${ENABLE_SOUND:=true}
133 133 ENABLE_DBUS=${ENABLE_DBUS:=true}
134 134 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
135 135 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
136 136 ENABLE_XORG=${ENABLE_XORG:=false}
137 137 ENABLE_WM=${ENABLE_WM:=""}
138 138 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
139 139 ENABLE_USER=${ENABLE_USER:=true}
140 140 USER_NAME=${USER_NAME:="pi"}
141 141 ENABLE_ROOT=${ENABLE_ROOT:=false}
142 142 ENABLE_QEMU=${ENABLE_QEMU:=false}
143 143 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
144 144
145 145 # SSH settings
146 146 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
147 147 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
148 148 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
149 149 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
150 150 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
151 151
152 152 # Advanced settings
153 153 ENABLE_SYSTEMDSWAP=${ENABLE_MINBASE:=false}
154 154 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
155 155 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
156 156 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
157 157 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
158 158 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
159 159 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
160 160 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
161 161 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
162 162 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
163 163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 164 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
165 165 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
166 166 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
167 167 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
168 168 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
169 169 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
170 170 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
171 171
172 172 # Kernel compilation settings
173 173 BUILD_KERNEL=${BUILD_KERNEL:=true}
174 174 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
175 175 KERNEL_THREADS=${KERNEL_THREADS:=1}
176 176 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
177 177 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
178 178 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
179 179 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
180 180 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
181 181 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
182 182 KERNEL_VIRT=${KERNEL_VIRT:=false}
183 183 KERNEL_BPF=${KERNEL_BPF:=false}
184 184 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
185 185
186 186 # Kernel compilation from source directory settings
187 187 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
188 188 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
189 189 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
190 190 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
191 191
192 192 # Reduce disk usage settings
193 193 REDUCE_APT=${REDUCE_APT:=true}
194 194 REDUCE_DOC=${REDUCE_DOC:=true}
195 195 REDUCE_MAN=${REDUCE_MAN:=true}
196 196 REDUCE_VIM=${REDUCE_VIM:=false}
197 197 REDUCE_BASH=${REDUCE_BASH:=false}
198 198 REDUCE_HWDB=${REDUCE_HWDB:=true}
199 199 REDUCE_SSHD=${REDUCE_SSHD:=true}
200 200 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
201 201
202 202 # Encrypted filesystem settings
203 203 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
204 204 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
205 205 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
206 206 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
207 207 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
208 208 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
209 209 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
210 210 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
211 211 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
212 212
213 213 # Chroot scripts directory
214 214 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
215 215
216 216 # Packages required in the chroot build environment
217 217 APT_INCLUDES=${APT_INCLUDES:=""}
218 218 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
219 219
220 220 #Packages to exclude from chroot build environment
221 221 APT_EXCLUDES=${APT_EXCLUDES:=""}
222 222
223 223 # Packages required for bootstrapping
224 224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
225 225 MISSING_PACKAGES=""
226 226
227 227 # Packages installed for c/c++ build environment in chroot (keep empty)
228 228 COMPILER_PACKAGES=""
229 229
230 230 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
231 231 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
232 232 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
233 233 APT_PROXY=http://127.0.0.1:3142/
234 234 fi
235 235
236 236 #netselect-apt does not know buster yet
237 237 if [ "$RELEASE" = "buster" ] ; then
238 238 RLS=testing
239 239 else
240 240 RLS="$RELEASE"
241 241 fi
242 242
243 243 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
244 244 rm "$(pwd)/files/apt/sources.list"
245 245 fi
246 246
247 247 if [ "$ENABLE_NONFREE" = true ] ; then
248 248 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
249 249 else
250 250 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
251 251 fi
252 252
253 253 #sed and cut the result string so we can use it as APT_SERVER
254 254 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
255 255
256 256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 257 if [ -n "$SET_ARCH" ] ; then
258 258 # 64-bit configuration
259 259 if [ "$SET_ARCH" = 64 ] ; then
260 260 # General 64-bit depended settings
261 261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
262 262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
263 263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
264 264
265 265 # Raspberry Pi model specific settings
266 266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
267 267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
268 268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
269 269 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
270 270 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
271 271 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
272 272 else
273 273 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
274 274 exit 1
275 275 fi
276 276 fi
277 277
278 278 # 32-bit configuration
279 279 if [ "$SET_ARCH" = 32 ] ; then
280 280 # General 32-bit dependend settings
281 281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
282 282 KERNEL_ARCH=${KERNEL_ARCH:=arm}
283 283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
284 284
285 285 # Raspberry Pi model specific settings
286 286 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
287 287 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
288 288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
289 289 RELEASE_ARCH=${RELEASE_ARCH:=armel}
290 290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
291 291 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
292 292 fi
293 293
294 294 # Raspberry Pi model specific settings
295 295 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
296 296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
297 297 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
298 298 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
299 299 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
300 300 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
301 301 fi
302 302 fi
303 303 #SET_ARCH not set
304 304 else
305 305 echo "error: Please set '32' or '64' as value for SET_ARCH"
306 306 exit 1
307 307 fi
308 308 # Device specific configuration and U-Boot configuration
309 309 case "$RPI_MODEL" in
310 310 0)
311 311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
312 312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
313 313 ;;
314 314 1)
315 315 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
316 316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
317 317 ;;
318 318 1P)
319 319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
320 320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
321 321 ;;
322 322 2)
323 323 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
324 324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
325 325 ;;
326 326 3)
327 327 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
328 328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
329 329 ;;
330 330 3P)
331 331 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
332 332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
333 333 ;;
334 334 *)
335 335 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
336 336 exit 1
337 337 ;;
338 338 esac
339 339
340 340 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
341 341 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
342 342 # Include bluetooth packages on supported boards
343 343 if [ "$ENABLE_BLUETOOTH" = true ] ; then
344 344 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
345 345 fi
346 346 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
347 347 # Check if the internal wireless interface is not supported by the RPi model
348 348 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
349 349 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
350 350 exit 1
351 351 fi
352 352 fi
353 353
354 354 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
355 355 echo "error: You have to compile kernel sources, if you want to enable nexmon"
356 356 exit 1
357 357 fi
358 358
359 359 # Prepare date string for default image file name
360 360 DATE="$(date +%Y-%m-%d)"
361 361 if [ -z "$KERNEL_BRANCH" ] ; then
362 362 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
363 363 else
364 364 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
365 365 fi
366 366
367 367 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
368 368 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
369 369 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
370 370 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
371 371 exit 1
372 372 fi
373 373 fi
374 374
375 375 set +x
376 376
377 377 # Add cmake to compile videocore sources
378 378 if [ "$ENABLE_VIDEOCORE" = true ] ; then
379 379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
380 380 fi
381 381
382 382 # Add deps for nexmon
383 383 if [ "$ENABLE_NEXMON" = true ] ; then
384 384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
385 385 fi
386 386
387 387 # Add libncurses5 to enable kernel menuconfig
388 388 if [ "$KERNEL_MENUCONFIG" = true ] ; then
389 389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
390 390 fi
391 391
392 392 # Add ccache compiler cache for (faster) kernel cross (re)compilation
393 393 if [ "$KERNEL_CCACHE" = true ] ; then
394 394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
395 395 fi
396 396
397 397 # Add cryptsetup package to enable filesystem encryption
398 398 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
399 399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
400 400 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
401 401
402 402 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
403 403 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
404 404 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
405 405 fi
406 406
407 407 if [ -z "$CRYPTFS_PASSWORD" ] ; then
408 408 echo "error: no password defined (CRYPTFS_PASSWORD)!"
409 409 exit 1
410 410 fi
411 411 ENABLE_INITRAMFS=true
412 412 fi
413 413
414 414 # Add initramfs generation tools
415 415 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
416 416 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
417 417 fi
418 418
419 419 # Add device-tree-compiler required for building the U-Boot bootloader
420 420 if [ "$ENABLE_UBOOT" = true ] ; then
421 421 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
422 422 else
423 423 if [ "$ENABLE_UBOOTUSB" = true ] ; then
424 424 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
425 425 exit 1
426 426 fi
427 427 fi
428 428
429 429 # Check if root SSH (v2) public key file exists
430 430 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
431 431 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
432 432 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
433 433 exit 1
434 434 fi
435 435 fi
436 436
437 437 # Check if $USER_NAME SSH (v2) public key file exists
438 438 if [ -n "$SSH_USER_PUB_KEY" ] ; then
439 439 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
440 440 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
441 441 exit 1
442 442 fi
443 443 fi
444 444
445 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
446 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
447 exit 1
448 fi
449
445 450 # Check if all required packages are installed on the build system
446 451 for package in $REQUIRED_PACKAGES ; do
447 452 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
448 453 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
449 454 fi
450 455 done
451 456
452 457 # If there are missing packages ask confirmation for install, or exit
453 458 if [ -n "$MISSING_PACKAGES" ] ; then
454 459 echo "the following packages needed by this script are not installed:"
455 460 echo "$MISSING_PACKAGES"
456 461
457 462 printf "\ndo you want to install the missing packages right now? [y/n] "
458 463 read -r confirm
459 464 [ "$confirm" != "y" ] && exit 1
460 465
461 466 # Make sure all missing required packages are installed
462 467 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
463 468 fi
464 469
465 470 # Check if ./bootstrap.d directory exists
466 471 if [ ! -d "./bootstrap.d/" ] ; then
467 472 echo "error: './bootstrap.d' required directory not found!"
468 473 exit 1
469 474 fi
470 475
471 476 # Check if ./files directory exists
472 477 if [ ! -d "./files/" ] ; then
473 478 echo "error: './files' required directory not found!"
474 479 exit 1
475 480 fi
476 481
477 482 # Check if specified KERNELSRC_DIR directory exists
478 483 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
479 484 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
480 485 exit 1
481 486 fi
482 487
483 488 # Check if specified UBOOTSRC_DIR directory exists
484 489 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
485 490 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
486 491 exit 1
487 492 fi
488 493
489 494 # Check if specified VIDEOCORESRC_DIR directory exists
490 495 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
491 496 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
492 497 exit 1
493 498 fi
494 499
495 500 # Check if specified FBTURBOSRC_DIR directory exists
496 501 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
497 502 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
498 503 exit 1
499 504 fi
500 505
501 506 # Check if specified NEXMONSRC_DIR directory exists
502 507 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
503 508 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
504 509 exit 1
505 510 fi
506 511
507 512 # Check if specified CHROOT_SCRIPTS directory exists
508 513 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
509 514 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
510 515 exit 1
511 516 fi
512 517
513 518 # Check if specified device mapping already exists (will be used by cryptsetup)
514 519 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
515 520 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
516 521 exit 1
517 522 fi
518 523
519 524 # Don't clobber an old build
520 525 if [ -e "$BUILDDIR" ] ; then
521 526 echo "error: directory ${BUILDDIR} already exists, not proceeding"
522 527 exit 1
523 528 fi
524 529
525 530 # Setup chroot directory
526 531 mkdir -p "${R}"
527 532
528 533 # Check if build directory has enough of free disk space >512MB
529 534 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
530 535 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
531 536 exit 1
532 537 fi
533 538
534 539 set -x
535 540
536 541 # Call "cleanup" function on various signals and errors
537 542 trap cleanup 0 1 2 3 6
538 543
539 544 # Add required packages for the minbase installation
540 545 if [ "$ENABLE_MINBASE" = true ] ; then
541 546 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
542 547 fi
543 548
544 549 # Add parted package, required to get partprobe utility
545 550 if [ "$EXPANDROOT" = true ] ; then
546 551 APT_INCLUDES="${APT_INCLUDES},parted"
547 552 fi
548 553
549 554 # Add dbus package, recommended if using systemd
550 555 if [ "$ENABLE_DBUS" = true ] ; then
551 556 APT_INCLUDES="${APT_INCLUDES},dbus"
552 557 fi
553 558
554 559 # Add iptables IPv4/IPv6 package
555 560 if [ "$ENABLE_IPTABLES" = true ] ; then
556 561 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
557 562 fi
558 563
559 564 # Add openssh server package
560 565 if [ "$ENABLE_SSHD" = true ] ; then
561 566 APT_INCLUDES="${APT_INCLUDES},openssh-server"
562 567 fi
563 568
564 569 # Add alsa-utils package
565 570 if [ "$ENABLE_SOUND" = true ] ; then
566 571 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
567 572 fi
568 573
569 574 # Add rng-tools package
570 575 if [ "$ENABLE_HWRANDOM" = true ] ; then
571 576 APT_INCLUDES="${APT_INCLUDES},rng-tools"
572 577 fi
573 578
574 579 # Add fbturbo video driver
575 580 if [ "$ENABLE_FBTURBO" = true ] ; then
576 581 # Enable xorg package dependencies
577 582 ENABLE_XORG=true
578 583 fi
579 584
580 585 # Add user defined window manager package
581 586 if [ -n "$ENABLE_WM" ] ; then
582 587 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
583 588
584 589 # Enable xorg package dependencies
585 590 ENABLE_XORG=true
586 591 fi
587 592
588 593 # Add xorg package
589 594 if [ "$ENABLE_XORG" = true ] ; then
590 595 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
591 596 fi
592 597
593 598 # Replace selected packages with smaller clones
594 599 if [ "$ENABLE_REDUCE" = true ] ; then
595 600 # Add levee package instead of vim-tiny
596 601 if [ "$REDUCE_VIM" = true ] ; then
597 602 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
598 603 fi
599 604
600 605 # Add dropbear package instead of openssh-server
601 606 if [ "$REDUCE_SSHD" = true ] ; then
602 607 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
603 608 fi
604 609 fi
605 610
606 611 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
607 612 if [ "$ENABLE_SYSVINIT" = false ] ; then
608 613 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
609 614 fi
610 615
611 616 # Configure kernel sources if no KERNELSRC_DIR
612 617 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
613 618 KERNELSRC_CONFIG=true
614 619 fi
615 620
616 621 # Configure reduced kernel
617 622 if [ "$KERNEL_REDUCE" = true ] ; then
618 623 KERNELSRC_CONFIG=false
619 624 fi
620 625
621 626 # Configure qemu compatible kernel
622 627 if [ "$ENABLE_QEMU" = true ] ; then
623 628 DTB_FILE=vexpress-v2p-ca15_a7.dtb
624 629 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
625 630 KERNEL_DEFCONFIG="vexpress_defconfig"
626 631 if [ "$KERNEL_MENUCONFIG" = false ] ; then
627 632 KERNEL_OLDDEFCONFIG=true
628 633 fi
629 634 fi
630 635
631 636 # Execute bootstrap scripts
632 637 for SCRIPT in bootstrap.d/*.sh; do
633 638 head -n 3 "$SCRIPT"
634 639 . "$SCRIPT"
635 640 done
636 641
637 642 ## Execute custom bootstrap scripts
638 643 if [ -d "custom.d" ] ; then
639 644 for SCRIPT in custom.d/*.sh; do
640 645 . "$SCRIPT"
641 646 done
642 647 fi
643 648
644 649 # Execute custom scripts inside the chroot
645 650 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
646 651 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
647 652 chroot_exec /bin/bash -x <<'EOF'
648 653 for SCRIPT in /chroot_scripts/* ; do
649 654 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
650 655 $SCRIPT
651 656 fi
652 657 done
653 658 EOF
654 659 rm -rf "${R}/chroot_scripts"
655 660 fi
656 661
657 662 # Remove c/c++ build environment from the chroot
658 663 chroot_remove_cc
659 664
660 665 # Generate required machine-id
661 666 MACHINE_ID=$(dbus-uuidgen)
662 667 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
663 668 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
664 669
665 670 # APT Cleanup
666 671 chroot_exec apt-get -y clean
667 672 chroot_exec apt-get -y autoclean
668 673 chroot_exec apt-get -y autoremove
669 674
670 675 # Unmount mounted filesystems
671 676 umount -l "${R}/proc"
672 677 umount -l "${R}/sys"
673 678
674 679 # Clean up directories
675 680 rm -rf "${R}/run/*"
676 681 rm -rf "${R}/tmp/*"
677 682
678 683 # Clean up files
679 684 rm -f "${ETC_DIR}/ssh/ssh_host_*"
680 685 rm -f "${ETC_DIR}/dropbear/dropbear_*"
681 686 rm -f "${ETC_DIR}/apt/sources.list.save"
682 687 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
683 688 rm -f "${ETC_DIR}/*-"
684 689 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
685 690 rm -f "${ETC_DIR}/resolv.conf"
686 691 rm -f "${R}/root/.bash_history"
687 692 rm -f "${R}/var/lib/urandom/random-seed"
688 693 rm -f "${R}/initrd.img"
689 694 rm -f "${R}/vmlinuz"
690 695 rm -f "${R}${QEMU_BINARY}"
691 696
692 697 if [ "$ENABLE_QEMU" = true ] ; then
693 698 # Setup QEMU directory
694 699 mkdir "${BASEDIR}/qemu"
695 700
696 701 # Copy kernel image to QEMU directory
697 702 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
698 703
699 704 # Copy kernel config to QEMU directory
700 705 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
701 706
702 707 # Copy kernel dtbs to QEMU directory
703 708 for dtb in "${BOOT_DIR}/"*.dtb ; do
704 709 if [ -f "${dtb}" ] ; then
705 710 install_readonly "${dtb}" "${BASEDIR}/qemu/"
706 711 fi
707 712 done
708 713
709 714 # Copy kernel overlays to QEMU directory
710 715 if [ -d "${BOOT_DIR}/overlays" ] ; then
711 716 # Setup overlays dtbs directory
712 717 mkdir "${BASEDIR}/qemu/overlays"
713 718
714 719 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
715 720 if [ -f "${dtb}" ] ; then
716 721 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
717 722 fi
718 723 done
719 724 fi
720 725
721 726 # Copy u-boot files to QEMU directory
722 727 if [ "$ENABLE_UBOOT" = true ] ; then
723 728 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
724 729 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
725 730 fi
726 731 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
727 732 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
728 733 fi
729 734 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
730 735 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
731 736 fi
732 737 fi
733 738
734 739 # Copy initramfs to QEMU directory
735 740 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
736 741 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
737 742 fi
738 743 fi
739 744
740 745 # Calculate size of the chroot directory in KB
741 746 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
742 747
743 748 # Calculate the amount of needed 512 Byte sectors
744 749 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
745 750 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
746 751 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
747 752
748 753 # The root partition is EXT4
749 754 # This means more space than the actual used space of the chroot is used.
750 755 # As overhead for journaling and reserved blocks 35% are added.
751 756 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
752 757
753 758 # Calculate required image size in 512 Byte sectors
754 759 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
755 760
756 761 # Prepare image file
757 762 if [ "$ENABLE_SPLITFS" = true ] ; then
758 763 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
759 764 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
760 765 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
761 766 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
762 767
763 768 # Write firmware/boot partition tables
764 769 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
765 770 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
766 771 EOM
767 772
768 773 # Write root partition table
769 774 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
770 775 ${TABLE_SECTORS},${ROOT_SECTORS},83
771 776 EOM
772 777
773 778 # Setup temporary loop devices
774 779 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
775 780 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
776 781 else # ENABLE_SPLITFS=false
777 782 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
778 783 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
779 784
780 785 # Write partition table
781 786 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
782 787 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
783 788 ${ROOT_OFFSET},${ROOT_SECTORS},83
784 789 EOM
785 790
786 791 # Setup temporary loop devices
787 792 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
788 793 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
789 794 fi
790 795
791 796 if [ "$ENABLE_CRYPTFS" = true ] ; then
792 797 # Create dummy ext4 fs
793 798 mkfs.ext4 "$ROOT_LOOP"
794 799
795 800 # Setup password keyfile
796 801 touch .password
797 802 chmod 600 .password
798 803 echo -n ${CRYPTFS_PASSWORD} > .password
799 804
800 805 # Initialize encrypted partition
801 806 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
802 807
803 808 # Open encrypted partition and setup mapping
804 809 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
805 810
806 811 # Secure delete password keyfile
807 812 shred -zu .password
808 813
809 814 # Update temporary loop device
810 815 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
811 816
812 817 # Wipe encrypted partition (encryption cipher is used for randomness)
813 818 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
814 819 fi
815 820
816 821 # Build filesystems
817 822 mkfs.vfat "$FRMW_LOOP"
818 823 mkfs.ext4 "$ROOT_LOOP"
819 824
820 825 # Mount the temporary loop devices
821 826 mkdir -p "$BUILDDIR/mount"
822 827 mount "$ROOT_LOOP" "$BUILDDIR/mount"
823 828
824 829 mkdir -p "$BUILDDIR/mount/boot/firmware"
825 830 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
826 831
827 832 # Copy all files from the chroot to the loop device mount point directory
828 833 rsync -a "${R}/" "$BUILDDIR/mount/"
829 834
830 835 # Unmount all temporary loop devices and mount points
831 836 cleanup
832 837
833 838 # Create block map file(s) of image(s)
834 839 if [ "$ENABLE_SPLITFS" = true ] ; then
835 840 # Create block map files for "bmaptool"
836 841 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
837 842 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
838 843
839 844 # Image was successfully created
840 845 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
841 846 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
842 847 else
843 848 # Create block map file for "bmaptool"
844 849 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
845 850
846 851 # Image was successfully created
847 852 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
848 853
849 854 # Create qemu qcow2 image
850 855 if [ "$ENABLE_QEMU" = true ] ; then
851 856 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
852 857 QEMU_SIZE=16G
853 858
854 859 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
855 860 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
856 861
857 862 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
858 863 fi
859 864 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant